Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ImmutableMultiset<E>

    java.lang.Object
      com.google.common.collect.ImmutableCollection<E>
          com.google.common.collect.ImmutableMultiset<E>

All Implemented Interfaces:
  Multiset<E>, Serializable, Iterable<E>, Collection<E>

    @GwtCompatible(serializable=true)
    public abstract class ImmutableMultiset<E>

extends ImmutableCollection<E>
implements Multiset<E>

An immutable hash-based multiset. Does not permit null elements.

Its iterator orders elements according to the first appearance of the element among the items passed to the factory method or builder. When the multiset contains multiple instances of an element, those instances are consecutive in the iteration order.

Since:
  2.0 (imported from Google Collections Library)
Author:
  Jared Levy, Louis Wasserman
See Also:
  Serialized Form

Nested Class Summary
`static class` | `ImmutableMultiset.Builder<E>` A builder for creating immutable multiset instances, especially `public static final` multisets ("constant multisets").

Nested classes/interfaces inherited from interface com.google.common.collect.Multiset
`Multiset.Entry<E>`

Method Summary
`int` | `add(E element, int occurrences)` Guaranteed to throw an exception and leave the collection unmodified.
`static
`<E> ImmutableMultiset.Builder<E>`
` | `builder()` Returns a new builder.
`boolean` | `contains(Object object)` Determines whether this multiset contains the specified element.
`boolean` | `containsAll(Collection<?> targets)` Returns `true` if this multiset contains at least one occurrence of each element in the specified collection.
`static
`<E> ImmutableMultiset<E>`
` | `copyOf(E[] elements)` Returns an immutable multiset containing the given elements.
`static
`<E> ImmutableMultiset<E>`
` | `copyOf(Iterable<? extends E> elements)` Returns an immutable multiset containing the given elements.
`static
`<E> ImmutableMultiset<E>`
` | `copyOf(Iterator<? extends E> elements)` Returns an immutable multiset containing the given elements.
`Set<Multiset.Entry<E>>` | `entrySet()` Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element.
`boolean` | `equals(Object object)` Compares the specified object with this multiset for equality.
`int` | `hashCode()` Returns the hash code for this multiset.
`UnmodifiableIterator<E>` | `iterator()` Returns an unmodifiable iterator across the elements in this collection.
`static
`<E> ImmutableMultiset<E>`
` | `of()` Returns the empty immutable multiset.
`static
`<E> ImmutableMultiset<E>`
` | `of(E element)` Returns an immutable multiset containing a single element.
`static
`<E> ImmutableMultiset<E>`
` | `of(E[] elements)` Deprecated. use `copyOf(Object[])`. This method is scheduled for deletion in January 2012.
`static
`<E> ImmutableMultiset<E>`
` | `of(E e1, E e2)` Returns an immutable multiset containing the given elements, in order.
`static
`<E> ImmutableMultiset<E>`
` | `of(E e1, E e2, E e3)` Returns an immutable multiset containing the given elements, in order.
`static
`<E> ImmutableMultiset<E>`
` | `of(E e1, E e2, E e3, E e4)` Returns an immutable multiset containing the given elements, in order.
`static
`<E> ImmutableMultiset<E>`
` | `of(E e1, E e2, E e3, E e4, E e5)` Returns an immutable multiset containing the given elements, in order.
`static
`<E> ImmutableMultiset<E>`
` | `of(E e1, E e2, E e3, E e4, E e5, E e6, E... others)` Returns an immutable multiset containing the given elements, in order.
`int` | `remove(Object element, int occurrences)` Guaranteed to throw an exception and leave the collection unmodified.
`int` | `setCount(E element, int count)` Guaranteed to throw an exception and leave the collection unmodified.
`boolean` | `setCount(E element, int oldCount, int newCount)` Guaranteed to throw an exception and leave the collection unmodified.
`String` | `toString()`

Methods inherited from class com.google.common.collect.ImmutableCollection
`add, addAll, asList, clear, isEmpty, remove, removeAll, retainAll, toArray, toArray`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.google.common.collect.Multiset
`add, count, elementSet, remove, removeAll, retainAll`

Methods inherited from interface java.util.Collection
`addAll, clear, isEmpty, size, toArray, toArray`

Method Detail

### of

    public static <E> ImmutableMultiset<E> of()

  Returns the empty immutable multiset.

### of

    public static <E> ImmutableMultiset<E> of(E element)

  Returns an immutable multiset containing a single element.

  Throws:
    `NullPointerException` - if `element` is null
  Since:
    6.0 (source-compatible since 2.0)

### of

    public static <E> ImmutableMultiset<E> of(E e1,
                                              E e2)

  Returns an immutable multiset containing the given elements, in order.

  Throws:
    `NullPointerException` - if any element is null
  Since:
    6.0 (source-compatible since 2.0)

### of

    public static <E> ImmutableMultiset<E> of(E e1,
                                              E e2,
                                              E e3)

  Returns an immutable multiset containing the given elements, in order.

  Throws:
    `NullPointerException` - if any element is null
  Since:
    6.0 (source-compatible since 2.0)

### of

    public static <E> ImmutableMultiset<E> of(E e1,
                                              E e2,
                                              E e3,
                                              E e4)

  Returns an immutable multiset containing the given elements, in order.

  Throws:
    `NullPointerException` - if any element is null
  Since:
    6.0 (source-compatible since 2.0)

### of

    public static <E> ImmutableMultiset<E> of(E e1,
                                              E e2,
                                              E e3,
                                              E e4,
                                              E e5)

  Returns an immutable multiset containing the given elements, in order.

  Throws:
    `NullPointerException` - if any element is null
  Since:
    6.0 (source-compatible since 2.0)

### of

    public static <E> ImmutableMultiset<E> of(E e1,
                                              E e2,
                                              E e3,
                                              E e4,
                                              E e5,
                                              E e6,
                                              E... others)

  Returns an immutable multiset containing the given elements, in order.

  Throws:
    `NullPointerException` - if any element is null
  Since:
    6.0 (source-compatible since 2.0)

### of

    @Deprecated
    public static <E> ImmutableMultiset<E> of(E[] elements)

  Deprecated. use `copyOf(Object[])`. This method is scheduled for deletion in January 2012.

  Returns an immutable multiset containing the given elements.

  The multiset is ordered by the first occurrence of each element. For example, `ImmutableMultiset.of(2, 3, 1, 3)` yields a multiset with elements in the order `2, 3, 3, 1`.

  Throws:
    `NullPointerException` - if any of `elements` is null
  Since:
    2.0 (changed from varargs in 6.0)

### copyOf

    public static <E> ImmutableMultiset<E> copyOf(E[] elements)

  Returns an immutable multiset containing the given elements.

  The multiset is ordered by the first occurrence of each element. For example, `ImmutableMultiset.copyOf([2, 3, 1, 3])` yields a multiset with elements in the order `2, 3, 3, 1`.

  Throws:
    `NullPointerException` - if any of `elements` is null
  Since:
    6.0

### copyOf

    public static <E> ImmutableMultiset<E> copyOf(Iterable<? extends E> elements)

  Returns an immutable multiset containing the given elements.

  The multiset is ordered by the first occurrence of each element. For example, `ImmutableMultiset.copyOf(Arrays.asList(2, 3, 1, 3))` yields a multiset with elements in the order `2, 3, 3, 1`.

  Despite the method name, this method attempts to avoid actually copying the data when it is safe to do so. The exact circumstances under which a copy will or will not be performed are undocumented and subject to change.

  Note: Despite what the method name suggests, if `elements` is an `ImmutableMultiset`, no copy will actually be performed, and the given multiset itself will be returned.

  Throws:
    `NullPointerException` - if any of `elements` is null

### copyOf

    public static <E> ImmutableMultiset<E> copyOf(Iterator<? extends E> elements)

  Returns an immutable multiset containing the given elements.

  The multiset is ordered by the first occurrence of each element. For example, `ImmutableMultiset.copyOf(Arrays.asList(2, 3, 1, 3).iterator())` yields a multiset with elements in the order `2, 3, 3, 1`.

  Throws:
    `NullPointerException` - if any of `elements` is null

### iterator

    public UnmodifiableIterator<E> iterator()

  Description copied from class: `ImmutableCollection`
  Returns an unmodifiable iterator across the elements in this collection.

  Specified by:
    `iterator` in interface `Multiset<E>`
  Specified by:
    `iterator` in interface `Iterable<E>`
  Specified by:
    `iterator` in interface `Collection<E>`
  Specified by:
    `iterator` in class `ImmutableCollection<E>`

### contains

    public boolean contains(@Nullable
                            Object object)

  Description copied from interface: `Multiset`
  Determines whether this multiset contains the specified element.

  This method refines `Collection.contains(java.lang.Object)` to further specify that it may not throw an exception in response to `element` being null or of the wrong type.

  Specified by:
    `contains` in interface `Multiset<E>`
  Specified by:
    `contains` in interface `Collection<E>`
  Overrides:
    `contains` in class `ImmutableCollection<E>`
  Parameters:
    `object` - the element to check for
  Returns:
    `true` if this multiset contains at least one occurrence of the element

### containsAll

    public boolean containsAll(Collection<?> targets)

  Description copied from interface: `Multiset`
  Returns `true` if this multiset contains at least one occurrence of each element in the specified collection.

  This method refines `Collection.containsAll(java.util.Collection)` to further specify that it may not throw an exception in response to any of `elements` being null or of the wrong type.

  Note: this method does not take into account the occurrence count of an element in the two collections; it may still return `true` even if `elements` contains several occurrences of an element and this multiset contains only one. This is no different than any other collection type like `List`, but it may be unexpected to the user of a multiset.

  Specified by:
    `containsAll` in interface `Multiset<E>`
  Specified by:
    `containsAll` in interface `Collection<E>`
  Overrides:
    `containsAll` in class `ImmutableCollection<E>`
  Parameters:
    `targets` - the collection of elements to be checked for containment in this multiset
  Returns:
    `true` if this multiset contains at least one occurrence of each element contained in `elements`

### add

    public final int add(E element,
                         int occurrences)

  Guaranteed to throw an exception and leave the collection unmodified.

  Specified by:
    `add` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add occurrences of; may be null only if explicitly allowed by the implementation
    `occurrences` - the number of occurrences of the element to add. May be zero, in which case no change will be made.
  Returns:
    the count of the element before the operation; possibly zero
  Throws:
    `UnsupportedOperationException` - always

### remove

    public final int remove(Object element,
                            int occurrences)

  Guaranteed to throw an exception and leave the collection unmodified.

  Specified by:
    `remove` in interface `Multiset<E>`
  Parameters:
    `element` - the element to conditionally remove occurrences of
    `occurrences` - the number of occurrences of the element to remove. May be zero, in which case no change will be made.
  Returns:
    the count of the element before the operation; possibly zero
  Throws:
    `UnsupportedOperationException` - always

### setCount

    public final int setCount(E element,
                              int count)

  Guaranteed to throw an exception and leave the collection unmodified.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add or remove occurrences of; may be null only if explicitly allowed by the implementation
    `count` - the desired count of the element in this multiset
  Returns:
    the count of the element before the operation; possibly zero
  Throws:
    `UnsupportedOperationException` - always

### setCount

    public final boolean setCount(E element,
                                  int oldCount,
                                  int newCount)

  Guaranteed to throw an exception and leave the collection unmodified.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to conditionally set the count of; may be null only if explicitly allowed by the implementation
    `oldCount` - the expected present count of the element in this multiset
    `newCount` - the desired count of the element in this multiset
  Returns:
    `true` if the condition for modification was met. This implies that the multiset was indeed modified, unless `oldCount == newCount`.
  Throws:
    `UnsupportedOperationException` - always

### equals

    public boolean equals(@Nullable
                          Object object)

  Description copied from interface: `Multiset`
  Compares the specified object with this multiset for equality. Returns `true` if the given object is also a multiset and contains equal elements with equal counts, regardless of order.

  Specified by:
    `equals` in interface `Multiset<E>`
  Specified by:
    `equals` in interface `Collection<E>`
  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Description copied from interface: `Multiset`
  Returns the hash code for this multiset. This is defined as the sum of

         ((element == null) ? 0 : element.hashCode()) ^ count(element)

  over all distinct elements in the multiset. It follows that a multiset and its entry set always have the same hash code.

  Specified by:
    `hashCode` in interface `Multiset<E>`
  Specified by:
    `hashCode` in interface `Collection<E>`
  Overrides:
    `hashCode` in class `Object`

### toString

    public String toString()

  Description copied from interface: `Multiset`

  It is recommended, though not mandatory, that this method return the result of invoking `Multiset.toString()` on the `Multiset.entrySet()`, yielding a result such as `[a x 3, c, d x 2, e]`.

  Specified by:
    `toString` in interface `Multiset<E>`
  Overrides:
    `toString` in class `ImmutableCollection<E>`

### entrySet

    public Set<Multiset.Entry<E>> entrySet()

  Description copied from interface: `Multiset`
  Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element. This set contains exactly one entry for each distinct element in the multiset (thus it always has the same size as the `Multiset.elementSet()`). The order of the elements in the element set is unspecified.

  The entry set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. However, multiset changes may or may not be reflected in any `Entry` instances already retrieved from the entry set (this is implementation-dependent). Furthermore, implementations are not required to support modifications to the entry set at all, and the `Entry` instances themselves don't even have methods for modification. See the specific implementation class for more details on how its entry set handles modifications.

  Specified by:
    `entrySet` in interface `Multiset<E>`
  Returns:
    a set of entries representing the data of this multiset

### builder

    public static <E> ImmutableMultiset.Builder<E> builder()

  Returns a new builder. The generated builder is equivalent to the builder created by the `ImmutableMultiset.Builder` constructor.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.